local obs = nil
local updatedPlayers = {}

TriggerEvent('chat:addSuggestion', '/playerObs', 'Set player observations, leave blank to remove obs', {
    { name="Text", help="The observation text" },
})

RegisterCommand('playerObs', function(source, args)
    if args[1] then
        local str = ''
        for i=1, #args, 1 do
            if i > 1 then str = str .. ' ' end
            str = str .. args[i]
        end
        obs = str
        playerObsThread()
        playerObsReminder()
        Notify('Observation Added')
    else
        Notify('Observation Removed')
        obs = nil
        updatedPlayers = {}
    end
end)

function playerObsReminder()
    Citizen.CreateThread(function()
        while obs ~= nil do
            Citizen.Wait(6000)
            TriggerEvent("chat:addMessage", { args = { "^3^*Observation Update^r", 'You still have an active player observation, run /playerObs to clear' } })
        end
    end) 
end

function playerObsThread()
    Citizen.CreateThread(function()
        local update = 0
        while obs ~= nil do
            update = update + 1
            PlayerCalculateObservations(update)
            Citizen.Wait(500)
        end
    end)
end

function PlayerCalculateObservations(update)
	local playerPos = GetEntityCoords(PlayerPedId(), true)
	for i, player in ipairs(GetActivePlayers()) do
        if player ~= PlayerId() then 
            local distance = #(playerPos - GetEntityCoords(GetPlayerPed(player), true))
            if distance < 2.0 and PlayerCanUpdateNotification(player, update) then
                TriggerServerEvent("PlayerObs:ObsNotification", GetPlayerServerId(player), PlayerConstructMessage())
            end
        end
	end
end

function PlayerConstructMessage()
	local message = "An individual nearby " .. obs
	return message
end

function PlayerCanUpdateNotification(player, update)
	if updatedPlayers[player] then
		if update - updatedPlayers[player] > 20 then
			updatedPlayers[player] = update
			return true
		end
		return false
	end
	updatedPlayers[player] = 0
	return true
end

function Notify(text)
    SetNotificationTextEntry("STRING")
    AddTextComponentString(text)
    DrawNotification(false, false)
end